/** @file DutBrApi.hc
 *
 *  Copyright (C) 2009-2010, Marvell International Ltd.
 *  All Rights Reserved
 */
 
#ifndef DUTBTAPI_HC
#define DUTBTAPI_HC

#define CHIPID_8688_NGM		(0x10)
#define CHIPID_8688_GM		(0x11)


#define MIN_NUM_BT_CH		(0)
#define MAX_NUM_BT_CH		(79)
#define BT_CHANNEL_INVALID	(-100)
#define CHANNEL_INIT_FREQ_MHZ		(2402)
#define MAX_NUM_BT_CHBANK		(8)

#define TOPPED					(0x8000)
#define BBGAIN_CODEPERDB		(2)

 

#define MASK_PWRCTRL_OPENLOOP		(0x10)
#define MASK_PWRCTRL_CLOSELOOP		(0x00)
#define MASK_PWRCTRL_EXTRANGE		(0x40)
#define MASK_PWRCTRL_FIXPPAPGA		(0x20)

 
#define  PWRCTRL_MRVL_C2			(0)
#define  PWRCTRL_MRVL_C1P5			(1)
#define  PWRCTRL_BT_CLASS2			(2)
#define  PWRCTRL_BT_CLASS1			(3)
enum
{
PWRCTRL_MRVL_C2_CLOSELOOP=(MASK_PWRCTRL_CLOSELOOP|PWRCTRL_MRVL_C2),
PWRCTRL_MRVL_C1P5_CLOSELOOP=(MASK_PWRCTRL_CLOSELOOP|PWRCTRL_MRVL_C1P5),
PWRCTRL_BT_CLASS2_CLOSELOOP=(MASK_PWRCTRL_CLOSELOOP|PWRCTRL_BT_CLASS2),
PWRCTRL_BT_CLASS1_CLOSELOOP=(MASK_PWRCTRL_CLOSELOOP|PWRCTRL_BT_CLASS1),
PWRCTRL_MRVL_C2EXT_CLOSELOOP=(MASK_PWRCTRL_CLOSELOOP|PWRCTRL_MRVL_C2|MASK_PWRCTRL_EXTRANGE),
PWRCTRL_MRVL_C1P5EXT_CLOSELOOP=(MASK_PWRCTRL_CLOSELOOP|PWRCTRL_MRVL_C1P5|MASK_PWRCTRL_EXTRANGE),
 
PWRCTRL_MRVL_C2_OPENLOOP=(MASK_PWRCTRL_OPENLOOP|PWRCTRL_MRVL_C2),
PWRCTRL_MRVL_C1P5_OPENLOOP=(MASK_PWRCTRL_OPENLOOP|PWRCTRL_MRVL_C1P5),
PWRCTRL_BT_CLASS2_OPENLOOP=(MASK_PWRCTRL_OPENLOOP|PWRCTRL_BT_CLASS2),
PWRCTRL_BT_CLASS1_OPENLOOP=(MASK_PWRCTRL_OPENLOOP|PWRCTRL_BT_CLASS1),
PWRCTRL_MRVL_C2EXT_OPENLOOP=(MASK_PWRCTRL_OPENLOOP|PWRCTRL_MRVL_C2|MASK_PWRCTRL_EXTRANGE),
PWRCTRL_MRVL_C1P5EXT_OPENLOOP=(MASK_PWRCTRL_OPENLOOP|PWRCTRL_MRVL_C1P5|MASK_PWRCTRL_EXTRANGE),
 
PWRCTRL_OPENLOOP=MASK_PWRCTRL_OPENLOOP,
PWRCTRL_FIXPPAPGA=MASK_PWRCTRL_FIXPPAPGA
};



#define MAX_BT_DATARATE			(3)
#define MIN_BT_DATARATE			(0)
#define NUM_BT_DATARATE			(MAX_BT_DATARATE - MIN_BT_DATARATE +1)

#define MAX_BT_HOPSLOT			(5)
#define MIN_BT_HOPSLOT			(0)
#define NUM_BT_HOPSLOT			(MAX_BT_HOPSLOT - MIN_BT_HOPSLOT +1)

#define NUM_PROTOCAL			(3)
enum
{
PROTOCAL_DATA_ACL,
PROTOCAL_DATA_SCO,
PROTOCAL_DATA_ESCO
};

#define DEF_IQSINEFREQ_INKHZ		(250)

#ifdef _W8689_	
#define STEP_IQSINEFREQ_INKHZ		(15.625)
#else //#ifdef _W8689_	
#define STEP_IQSINEFREQ_INKHZ		(62.5)
#endif //#ifdef _W8689_	

#define MIN_IQSINEFREQ_INKHZ		(STEP_IQSINEFREQ_INKHZ)
#define MAX_IQSINEFREQ_INKHZ		(4000)



enum
{
PAYLOADPATTERN_ALL0, 
PAYLOADPATTERN_ALL1,
PAYLOADPATTERN_PN9, 
PAYLOADPATTERN_HEX_AA,
PAYLOADPATTERN_HEX_F0,
PAYLOADPATTERN_LOOPBACK_ACL,
PAYLOADPATTERN_CLOSED_LOOP_SCO_PACKETS,
PAYLOADPATTERN_CLOSED_LOOP_ESCO_PACKETS,
PAYLOADPATTERN_ABORT=0xFF};

// ACL 
//   DM1 = 0x01;   DM3 = 0x03;   DM5 = 0x05; (GFSK, 1M FEC)
//   DH1 = 0x11;   DH3 = 0x13;   DH5 = 0x15; (GFSK, 1M)
// 2-DH1 = 0x21; 2-DH3 = 0x23; 2-DH5 = 0x25; (DQPSK, 2M)
// 3-DH1 = 0x31; 3-DH3 = 0x33; 3-DH5 = 0x35; (8PSK, 3M)

// Sco:
// HV1 = 0x11;   HV2 = 0x12;   HV3 = 0x13; (GFSK, 1M)

// eSco:
//   EV3 = 0x13;   EV4 = 0x14;   EV5 = 0x15; (GFSK, 1M)
// 2-EV3 = 0x23; 2-EV5 = 0x25;		 (DQPSK, 2M)
// 3-EV3 = 0x33; 3-EV5 = 0x35;		 (8PSK, 3M)

enum
{
	DATARATE_1M_GFSK_FEC,
	DATARATE_1M_GFSK,	
	DATARATE_2M_DQPSK,
	DATARATE_3M_8PSK
};
enum
{
TIMESLOT_1SLOT=1,
TIMESLOT_2SLOT,
TIMESLOT_3SLOT,
TIMESLOT_4SLOT,
TIMESLOT_5SLOT 
};

#define PACKETTYPE(dataRate,slot) ((dataRate)<<4 | slot)

#define PACKETTYPE_ACL_DM1		PACKETTYPE(DATARATE_1M_GFSK_FEC,TIMESLOT_1SLOT)
#define PACKETTYPE_ACL_DM3		PACKETTYPE(DATARATE_1M_GFSK_FEC,TIMESLOT_3SLOT)
#define PACKETTYPE_ACL_DM5		PACKETTYPE(DATARATE_1M_GFSK_FEC,TIMESLOT_5SLOT)
#define PACKETTYPE_ACL_DH1		PACKETTYPE(DATARATE_1M_GFSK,	TIMESLOT_1SLOT)
#define PACKETTYPE_ACL_DH3		PACKETTYPE(DATARATE_1M_GFSK,	TIMESLOT_3SLOT)
#define PACKETTYPE_ACL_DH5		PACKETTYPE(DATARATE_1M_GFSK,	TIMESLOT_5SLOT)
#define PACKETTYPE_ACL_2DH1		PACKETTYPE(DATARATE_2M_DQPSK,	TIMESLOT_1SLOT)
#define PACKETTYPE_ACL_2DH3		PACKETTYPE(DATARATE_2M_DQPSK,	TIMESLOT_3SLOT)
#define PACKETTYPE_ACL_2DH5		PACKETTYPE(DATARATE_2M_DQPSK,	TIMESLOT_5SLOT)
#define PACKETTYPE_ACL_3DH1		PACKETTYPE(DATARATE_3M_8PSK,	TIMESLOT_1SLOT)
#define PACKETTYPE_ACL_3DH3		PACKETTYPE(DATARATE_3M_8PSK,	TIMESLOT_3SLOT)
#define PACKETTYPE_ACL_3DH5		PACKETTYPE(DATARATE_3M_8PSK,	TIMESLOT_5SLOT)


#define PACKETTYPE_SCO_HV1		PACKETTYPE(DATARATE_1M_GFSK,	TIMESLOT_1SLOT)
#define PACKETTYPE_SCO_HV2		PACKETTYPE(DATARATE_1M_GFSK,	TIMESLOT_2SLOT)
#define PACKETTYPE_SCO_HV3		PACKETTYPE(DATARATE_1M_GFSK,	TIMESLOT_3SLOT)


#define PACKETTYPE_ESCO_EV3		PACKETTYPE(DATARATE_1M_GFSK,	TIMESLOT_3SLOT)
#define PACKETTYPE_ESCO_EV4		PACKETTYPE(DATARATE_1M_GFSK,	TIMESLOT_4SLOT)
#define PACKETTYPE_ESCO_EV5		PACKETTYPE(DATARATE_1M_GFSK,	TIMESLOT_5SLOT)
#define PACKETTYPE_ESCO_2EV3	PACKETTYPE(DATARATE_2M_DQPSK,	TIMESLOT_3SLOT)
#define PACKETTYPE_ESCO_2EV5	PACKETTYPE(DATARATE_2M_DQPSK,	TIMESLOT_5SLOT)
#define PACKETTYPE_ESCO_3EV3	PACKETTYPE(DATARATE_3M_8PSK,	TIMESLOT_3SLOT)
#define PACKETTYPE_ESCO_3EV5	PACKETTYPE(DATARATE_3M_8PSK,	TIMESLOT_5SLOT)


#define DEF_PACKETTYPE			(PACKETTYPE_ACL_DH1)


#define DEF_PAYLOADPATTERN		(PAYLOADPATTERN_PN9)
#define MIN_PAYLOADPATTERN		(PAYLOADPATTERN_ALL0)
#define MAX_PAYLOADPATTERN		(PAYLOADPATTERN_CLOSED_LOOP_ESCO_PACKETS)

#define PAYLOADLENGTH_MAXIMUN_POSSIBLE		(-1)

#define MAXSAVED_PWRLVL_C2 				(2)
#define MAXSAVED_PWRLVL_C1_5 			(3)

//#define MAXSTRLEN_LOCALDEVICENAME	(256)
#define MAXSTRLEN_LOCALDEVICENAME	(64)

#define SIZE_BDADDRESS_INBYTE				(6)
#define DEF_BDADDRESS						(0x0102030405)
#define DEF_AMADDRESS						(1)
#define DEF_CORRELATION_THRESHOLD			(0x1F)
#define DEF_CORRELATION_WINDOW				(100) // byte

#define SIZE_LINKKEY_INBYTE					(16)

#define LEN_PRBS_INBYTE						(16)

#define MAXPARTNER 							(16)
#define NUM_WORD_SUPPORTFEATURE 			(4)
#define NUM_WORD_SUPPORTCOMMAND 			(9)
#define MAX_BYTE_SECURITYKEY				(16)

#define MAXPARTNER_REVD 					(3)

#ifndef MAX_LENGTH
#define MAX_LENGTH							(256)
#endif 

#ifdef _W8689_
#define CHIPID_8688		(0x11)
#define CHIPID_8689		(0x15)
#define XTALMAX			(0xFF)
#define XTALCENTER		(0x7F)
#define XTALMIN			(0x0)
#endif //#ifndef _W8689_



#define	DEFVALUE_BT_INITPWR							(0x04)
#define	DEFVALUE_BT_FORCECLASS20					(0x00)
#define	DEFVALUE_BT_DISABLE_PWR_CONTROL				(0x00)
#define	DEFVALUE_BT_MISC_FLAG						(0x00)
#define	DEFVALUE_BT_USED_INTERNAL_SLEEP_CLOCK		(0x00)

#define	DEFVALUE_BT_RSSIGOLDENLOW		(-70)
#define	DEFVALUE_BT_RSSIGOLDENHIGH		(-50)
#define	DEFVALUE_BT_UARTBAUDRATE		(3000000)
#define	DEFVALUE_BT_ENCRYP_KEY_LEN_MAX		(0xF)
#define	DEFVALUE_BT_ENCRYP_KEY_LEN_MIN		(0x0)

#endif //#ifndef DUTBTAPI_HC
